java.util.concurrent

## Class ConcurrentHashMap<K,V>

- java.lang.Object
- - java.util.AbstractMap<K,V>
  - - java.util.concurrent.ConcurrentHashMap<K,V>

- Type Parameters:
    `K` - the type of keys maintained by this map
    `V` - the type of mapped values
  All Implemented Interfaces:
    Serializable, ConcurrentMap<K,V>, Map<K,V>

      public class ConcurrentHashMap<K,V>
      extends AbstractMap<K,V>
      implements ConcurrentMap<K,V>, Serializable

  A hash table supporting full concurrency of retrievals and adjustable expected concurrency for updates. This class obeys the same functional specification as `Hashtable`, and includes versions of methods corresponding to each method of `Hashtable`. However, even though all operations are thread-safe, retrieval operations do not entail locking, and there is not any support for locking the entire table in a way that prevents all access. This class is fully interoperable with `Hashtable` in programs that rely on its thread safety but not on its synchronization details.

  Retrieval operations (including `get`) generally do not block, so may overlap with update operations (including `put` and `remove`). Retrievals reflect the results of the most recently completed update operations holding upon their onset. For aggregate operations such as `putAll` and `clear`, concurrent retrievals may reflect insertion or removal of only some entries. Similarly, Iterators and Enumerations return elements reflecting the state of the hash table at some point at or since the creation of the iterator/enumeration. They do not throw `ConcurrentModificationException`. However, iterators are designed to be used by only one thread at a time.

  The allowed concurrency among update operations is guided by the optional `concurrencyLevel` constructor argument (default `16`), which is used as a hint for internal sizing. The table is internally partitioned to try to permit the indicated number of concurrent updates without contention. Because placement in hash tables is essentially random, the actual concurrency will vary. Ideally, you should choose a value to accommodate as many threads as will ever concurrently modify the table. Using a significantly higher value than you need can waste space and time, and a significantly lower value can lead to thread contention. But overestimates and underestimates within an order of magnitude do not usually have much noticeable impact. A value of one is appropriate when it is known that only one thread will modify and all others will only read. Also, resizing this or any other kind of hash table is a relatively slow operation, so, when possible, it is a good idea to provide estimates of expected table sizes in constructors.

  This class and its views and iterators implement all of the optional methods of the `Map` and `Iterator` interfaces.

  Like `Hashtable` but unlike `HashMap`, this class does not allow `null` to be used as a key or value.

  This class is a member of the Java Collections Framework.

  Since:
    1.5
  Author:
    Doug Lea
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K,V>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConcurrentHashMap()` Creates a new, empty map with a default initial capacity (16), load factor (0.75) and concurrencyLevel (16).
    `ConcurrentHashMap(int initialCapacity)` Creates a new, empty map with the specified initial capacity, and with default load factor (0.75) and concurrencyLevel (16).
    `ConcurrentHashMap(int initialCapacity, float loadFactor)` Creates a new, empty map with the specified initial capacity and load factor and with the default concurrencyLevel (16).
    `ConcurrentHashMap(int initialCapacity, float loadFactor, int concurrencyLevel)` Creates a new, empty map with the specified initial capacity, load factor and concurrency level.
    `ConcurrentHashMap(Map<? extends K,? extends V> m)` Creates a new map with the same mappings as the given map.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Removes all of the mappings from this map (optional operation).
    `boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
    `boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
    `Set<Map.Entry<K,V>>` | `entrySet()` Returns a `Set` view of the mappings contained in this map.
    `boolean` | `equals(Object o)` Compares the specified object with this map for equality.
    `V` | `get(Object key)` Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
    `int` | `hashCode()` Returns the hash code value for this map.
    `boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
    `Set<K>` | `keySet()` Returns a `Set` view of the keys contained in this map.
    `V` | `put(K key, V value)` Associates the specified value with the specified key in this map (optional operation).
    `void` | `putAll(Map<? extends K,? extends V> m)` Copies all of the mappings from the specified map to this map (optional operation).
    `V` | `putIfAbsent(K key, V value)` If the specified key is not already associated with a value, associate it with the given value.
    `V` | `remove(Object key)` Removes the mapping for a key from this map if it is present (optional operation).
    `boolean` | `remove(Object key, Object value)` Removes the entry for a key only if currently mapped to a given value.
    `V` | `replace(K key, V value)` Replaces the entry for a key only if currently mapped to some value.
    `boolean` | `replace(K key, V oldValue, V newValue)` Replaces the entry for a key only if currently mapped to a given value.
    `int` | `size()` Returns the number of key-value mappings in this map.
    `String` | `toString()` Returns a string representation of this map.
    `Collection<V>` | `values()` Returns a `Collection` view of the values contained in this map.

    - ### Methods inherited from class java.util.AbstractMap

      `clone`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, replaceAll`

- - ### Constructor Detail

    - #### ConcurrentHashMap

          public ConcurrentHashMap(int initialCapacity,
                                   float loadFactor,
                                   int concurrencyLevel)

      Creates a new, empty map with the specified initial capacity, load factor and concurrency level.
      Parameters:
        `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements.
        `loadFactor` - the load factor threshold, used to control resizing. Resizing may be performed when the average number of elements per bin exceeds this threshold.
        `concurrencyLevel` - the estimated number of concurrently updating threads. The implementation performs internal sizing to try to accommodate this many threads.
      Throws:
        `IllegalArgumentException` - if the initial capacity is negative or the load factor or concurrencyLevel are nonpositive.

    - #### ConcurrentHashMap

          public ConcurrentHashMap(int initialCapacity,
                                   float loadFactor)

      Creates a new, empty map with the specified initial capacity and load factor and with the default concurrencyLevel (16).
      Parameters:
        `initialCapacity` - The implementation performs internal sizing to accommodate this many elements.
        `loadFactor` - the load factor threshold, used to control resizing. Resizing may be performed when the average number of elements per bin exceeds this threshold.
      Throws:
        `IllegalArgumentException` - if the initial capacity of elements is negative or the load factor is nonpositive
      Since:
        1.6

    - #### ConcurrentHashMap

          public ConcurrentHashMap(int initialCapacity)

      Creates a new, empty map with the specified initial capacity, and with default load factor (0.75) and concurrencyLevel (16).
      Parameters:
        `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements.
      Throws:
        `IllegalArgumentException` - if the initial capacity of elements is negative.

    - #### ConcurrentHashMap

          public ConcurrentHashMap()

      Creates a new, empty map with a default initial capacity (16), load factor (0.75) and concurrencyLevel (16).

    - #### ConcurrentHashMap

          public ConcurrentHashMap(Map<? extends K,? extends V> m)

      Creates a new map with the same mappings as the given map. The map is created with a capacity of 1.5 times the number of mappings in the given map or 16 (whichever is greater), and a default load factor (0.75) and concurrencyLevel (16).
      Parameters:
        `m` - the map

  - ### Method Detail

    - #### size

          public int size()

      Description copied from class: `AbstractMap`
      Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

      This implementation returns `entrySet().size()`.

      Specified by:
        `size` in interface `Map<K,V>`
      Overrides:
        `size` in class `AbstractMap<K,V>`
      Returns:
        the number of key-value mappings in this map

    - #### isEmpty

          public boolean isEmpty()

      Description copied from class: `AbstractMap`
      Returns `true` if this map contains no key-value mappings.

      This implementation returns `size() == 0`.

      Specified by:
        `isEmpty` in interface `Map<K,V>`
      Overrides:
        `isEmpty` in class `AbstractMap<K,V>`
      Returns:
        `true` if this map contains no key-value mappings

    - #### containsKey

          public boolean containsKey(Object key)

      Description copied from class: `AbstractMap`
      Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains a mapping for a key `k` such that `(key==null ? k==null : key.equals(k))`. (There can be at most one such mapping.)

      This implementation iterates over `entrySet()` searching for an entry with the specified key. If such an entry is found, `true` is returned. If the iteration terminates without finding such an entry, `false` is returned. Note that this implementation requires linear time in the size of the map; many implementations will override this method.

      Specified by:
        `containsKey` in interface `Map<K,V>`
      Overrides:
        `containsKey` in class `AbstractMap<K,V>`
      Parameters:
        `key` - key whose presence in this map is to be tested
      Returns:
        `true` if this map contains a mapping for the specified key

    - #### containsValue

          public boolean containsValue(Object value)

      Description copied from class: `AbstractMap`
      Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.

      This implementation iterates over `entrySet()` searching for an entry with the specified value. If such an entry is found, `true` is returned. If the iteration terminates without finding such an entry, `false` is returned. Note that this implementation requires linear time in the size of the map.

      Specified by:
        `containsValue` in interface `Map<K,V>`
      Overrides:
        `containsValue` in class `AbstractMap<K,V>`
      Parameters:
        `value` - value whose presence in this map is to be tested
      Returns:
        `true` if this map maps one or more keys to the specified value

    - #### get

          public V get(Object key)

      Description copied from class: `AbstractMap`
      Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.

      More formally, if this map contains a mapping from a key `k` to a value `v` such that `(key==null ? k==null : key.equals(k))`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

      If this map permits null values, then a return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

      This implementation iterates over `entrySet()` searching for an entry with the specified key. If such an entry is found, the entry's value is returned. If the iteration terminates without finding such an entry, `null` is returned. Note that this implementation requires linear time in the size of the map; many implementations will override this method.

      Specified by:
        `get` in interface `Map<K,V>`
      Overrides:
        `get` in class `AbstractMap<K,V>`
      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which the specified key is mapped, or `null` if this map contains no mapping for the key

    - #### put

          public V put(K key,
                       V value)

      Description copied from class: `AbstractMap`
      Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for the key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if `m.containsKey(k)` would return `true`.)

      This implementation always throws an `UnsupportedOperationException`.

      Specified by:
        `put` in interface `Map<K,V>`
      Overrides:
        `put` in class `AbstractMap<K,V>`
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)

    - #### remove

          public V remove(Object key)

      Description copied from class: `AbstractMap`
      Removes the mapping for a key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `(key==null ? k==null : key.equals(k))`, that mapping is removed. (The map can contain at most one such mapping.)

      Returns the value to which this map previously associated the key, or `null` if the map contained no mapping for the key.

      If this map permits null values, then a return value of `null` does not necessarily indicate that the map contained no mapping for the key; it's also possible that the map explicitly mapped the key to `null`.

      The map will not contain a mapping for the specified key once the call returns.

      This implementation iterates over `entrySet()` searching for an entry with the specified key. If such an entry is found, its value is obtained with its `getValue` operation, the entry is removed from the collection (and the backing map) with the iterator's `remove` operation, and the saved value is returned. If the iteration terminates without finding such an entry, `null` is returned. Note that this implementation requires linear time in the size of the map; many implementations will override this method.

      Note that this implementation throws an `UnsupportedOperationException` if the `entrySet` iterator does not support the `remove` method and this map contains a mapping for the specified key.

      Specified by:
        `remove` in interface `Map<K,V>`
      Overrides:
        `remove` in class `AbstractMap<K,V>`
      Parameters:
        `key` - key whose mapping is to be removed from the map
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`.

    - #### putAll

          public void putAll(Map<? extends K,? extends V> m)

      Description copied from class: `AbstractMap`
      Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling `put(k, v)` on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is undefined if the specified map is modified while the operation is in progress.

      This implementation iterates over the specified map's `entrySet()` collection, and calls this map's `put` operation once for each entry returned by the iteration.

      Note that this implementation throws an `UnsupportedOperationException` if this map does not support the `put` operation and the specified map is nonempty.

      Specified by:
        `putAll` in interface `Map<K,V>`
      Overrides:
        `putAll` in class `AbstractMap<K,V>`
      Parameters:
        `m` - mappings to be stored in this map

    - #### clear

          public void clear()

      Description copied from class: `AbstractMap`
      Removes all of the mappings from this map (optional operation). The map will be empty after this call returns.

      This implementation calls `entrySet().clear()`.

      Note that this implementation throws an `UnsupportedOperationException` if the `entrySet` does not support the `clear` operation.

      Specified by:
        `clear` in interface `Map<K,V>`
      Overrides:
        `clear` in class `AbstractMap<K,V>`

    - #### keySet

          public Set<K> keySet()

      Description copied from class: `AbstractMap`
      Returns a `Set` view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

      This implementation returns a set that subclasses `AbstractSet`. The subclass's iterator method returns a "wrapper object" over this map's `entrySet()` iterator. The `size` method delegates to this map's `size` method and the `contains` method delegates to this map's `containsKey` method.

      The set is created the first time this method is called, and returned in response to all subsequent calls. No synchronization is performed, so there is a slight chance that multiple calls to this method will not all return the same set.

      Specified by:
        `keySet` in interface `Map<K,V>`
      Overrides:
        `keySet` in class `AbstractMap<K,V>`
      Returns:
        a set view of the keys contained in this map

    - #### values

          public Collection<V> values()

      Description copied from class: `AbstractMap`
      Returns a `Collection` view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

      This implementation returns a collection that subclasses `AbstractCollection`. The subclass's iterator method returns a "wrapper object" over this map's `entrySet()` iterator. The `size` method delegates to this map's `size` method and the `contains` method delegates to this map's `containsValue` method.

      The collection is created the first time this method is called, and returned in response to all subsequent calls. No synchronization is performed, so there is a slight chance that multiple calls to this method will not all return the same collection.

      Specified by:
        `values` in interface `Map<K,V>`
      Overrides:
        `values` in class `AbstractMap<K,V>`
      Returns:
        a collection view of the values contained in this map

    - #### entrySet

          public Set<Map.Entry<K,V>> entrySet()

      Description copied from interface: `Map`
      Returns a `Set` view of the mappings contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation, or through the `setValue` operation on a map entry returned by the iterator) the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `entrySet` in interface `Map<K,V>`
      Specified by:
        `entrySet` in class `AbstractMap<K,V>`
      Returns:
        a set view of the mappings contained in this map

    - #### equals

          public boolean equals(Object o)

      Description copied from class: `AbstractMap`
      Compares the specified object with this map for equality. Returns `true` if the given object is also a map and the two maps represent the same mappings. More formally, two maps `m1` and `m2` represent the same mappings if `m1.entrySet().equals(m2.entrySet())`. This ensures that the `equals` method works properly across different implementations of the `Map` interface.

      This implementation first checks if the specified object is this map; if so it returns `true`. Then, it checks if the specified object is a map whose size is identical to the size of this map; if not, it returns `false`. If so, it iterates over this map's `entrySet` collection, and checks that the specified map contains each mapping that this map contains. If the specified map fails to contain such a mapping, `false` is returned. If the iteration completes, `true` is returned.

      Specified by:
        `equals` in interface `Map<K,V>`
      Overrides:
        `equals` in class `AbstractMap<K,V>`
      Parameters:
        `o` - object to be compared for equality with this map
      Returns:
        `true` if the specified object is equal to this map
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### hashCode

          public int hashCode()

      Description copied from class: `AbstractMap`
      Returns the hash code value for this map. The hash code of a map is defined to be the sum of the hash codes of each entry in the map's `entrySet()` view. This ensures that `m1.equals(m2)` implies that `m1.hashCode()==m2.hashCode()` for any two maps `m1` and `m2`, as required by the general contract of `Object.hashCode()`.

      This implementation iterates over `entrySet()`, calling `hashCode()` on each element (entry) in the set, and adding up the results.

      Specified by:
        `hashCode` in interface `Map<K,V>`
      Overrides:
        `hashCode` in class `AbstractMap<K,V>`
      Returns:
        the hash code value for this map
      See Also:
        `Map.Entry.hashCode()`, `Object.equals(Object)`, `Set.equals(Object)`

    - #### toString

          public String toString()

      Description copied from class: `AbstractMap`
      Returns a string representation of this map. The string representation consists of a list of key-value mappings in the order returned by the map's `entrySet` view's iterator, enclosed in braces (`"{}"`). Adjacent mappings are separated by the characters `", "` (comma and space). Each key-value mapping is rendered as the key followed by an equals sign (`"="`) followed by the associated value. Keys and values are converted to strings as by `String.valueOf(Object)`.
      Overrides:
        `toString` in class `AbstractMap<K,V>`
      Returns:
        a string representation of this map

    - #### putIfAbsent

          public V putIfAbsent(K key,
                               V value)

      Description copied from interface: `ConcurrentMap`
      If the specified key is not already associated with a value, associate it with the given value. This is equivalent to

             if (!map.containsKey(key))
                 return map.put(key, value);
             else
                 return map.get(key);

      except that the action is performed atomically.
      Specified by:
        `putIfAbsent` in interface `ConcurrentMap<K,V>`
      Specified by:
        `putIfAbsent` in interface `Map<K,V>`
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with the specified key, or `null` if there was no mapping for the key. (A `null` return can also indicate that the map previously associated `null` with the key, if the implementation supports null values.)

    - #### remove

          public boolean remove(Object key,
                                Object value)

      Description copied from interface: `ConcurrentMap`
      Removes the entry for a key only if currently mapped to a given value. This is equivalent to

             if (map.containsKey(key) && map.get(key).equals(value)) {
                 map.remove(key);
                 return true;
             } else return false;

      except that the action is performed atomically.
      Specified by:
        `remove` in interface `ConcurrentMap<K,V>`
      Specified by:
        `remove` in interface `Map<K,V>`
      Parameters:
        `key` - key with which the specified value is associated
        `value` - value expected to be associated with the specified key
      Returns:
        `true` if the value was removed

    - #### replace

          public boolean replace(K key,
                                 V oldValue,
                                 V newValue)

      Description copied from interface: `ConcurrentMap`
      Replaces the entry for a key only if currently mapped to a given value. This is equivalent to

             if (map.containsKey(key) && map.get(key).equals(oldValue)) {
                 map.put(key, newValue);
                 return true;
             } else return false;

      except that the action is performed atomically.
      Specified by:
        `replace` in interface `ConcurrentMap<K,V>`
      Specified by:
        `replace` in interface `Map<K,V>`
      Parameters:
        `key` - key with which the specified value is associated
        `oldValue` - value expected to be associated with the specified key
        `newValue` - value to be associated with the specified key
      Returns:
        `true` if the value was replaced

    - #### replace

          public V replace(K key,
                           V value)

      Description copied from interface: `ConcurrentMap`
      Replaces the entry for a key only if currently mapped to some value. This is equivalent to

             if (map.containsKey(key)) {
                 return map.put(key, value);
             } else return null;

      except that the action is performed atomically.
      Specified by:
        `replace` in interface `ConcurrentMap<K,V>`
      Specified by:
        `replace` in interface `Map<K,V>`
      Parameters:
        `key` - key with which the specified value is associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with the specified key, or `null` if there was no mapping for the key. (A `null` return can also indicate that the map previously associated `null` with the key, if the implementation supports null values.)

Copyright © 2025 API Design. All Rights Reserved.